﻿// PARTICLE EXPERIMENTS
// Author : Seb Lee-Delisle
// Blog : www.sebleedelisle.com
// Company : www.pluginmedia.net
//
// This work is licensed under a Creative Commons  2.0 License.

// Full details at 
// http://creativecommons.org/licenses/by/2.0/uk/

// You may re-use this code as you wish, but a credit would be 
// appreciated. And I'd love to see what you do with it! 
// mail me : seb@sebleedelisle.com

package 
{

import flash.display.*;	
	
public class Particle 
{ 

	public var xVel:Number;
	public var yVel:Number;
	public var drag:Number = 1;
	public var fade:Number = 1;
	public var shrink:Number = 1;
	public var gravity:Number = 0;
	public var directionRotate:Boolean = false; 
	
	public var clip:Sprite;
	
	public function Particle(spriteclass:Class, targetclip:DisplayObjectContainer, xpos:Number, ypos:Number){
			
		clip = new spriteclass(); 
		
		targetclip.addChild(clip); 
		
		clip.x = xpos;
		clip.y = ypos;

	}
	
	public function setVel(xvel:Number, yvel:Number){
		xVel = xvel;
		yVel = yvel;
	}
	
	public function setScale(newscale:Number){
		clip.scaleX = clip.scaleY = newscale;
	}
	
	public function update(){
		
		// add the velocity to the particle's position... 
		clip.x += xVel;
		clip.y += yVel;
		
		// apply drag
		xVel*=drag;
		yVel*=drag;
		
		// fade out
		clip.alpha = (clip.alpha*1000)*fade/1000;
		
		// scale
		clip.scaleX = clip.scaleY *=shrink;
		
		// gravity
		yVel+=gravity;
		
		if(directionRotate) {
			
			updateRotation(); 
		}
	}
	public function updateRotation()
	{
		clip.rotation = Math.atan2(yVel,xVel)*(180/Math.PI); 
	}
	
	public function destroy():void
	{
		clip.parent.removeChild(clip); 
		
	}
}
}